from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Directory

Slurmrunnerbasic_Pl_V0_1_0 = CommandToolBuilder(tool="slurmrunnerbasic.pl", base_command=["slurmrunnerbasic.pl"], inputs=[ToolInput(tag="in_in_file", input_type=Boolean(optional=True), prefix="--infile", doc=InputDocumentation(doc="- Str. File of commands separated by newline.\nThe command 'wait' indicates all previous\ncommands should finish before starting the\nnext one.")), ToolInput(tag="in_module", input_type=Boolean(optional=True), prefix="--module", doc=InputDocumentation(doc="- ArrayRef. List of modules to load ex. R2,\nsamtools, etc")), ToolInput(tag="in_after_ok", input_type=Boolean(optional=True), prefix="--afterok", doc=InputDocumentation(doc="- ArrayRef.")), ToolInput(tag="in_man", input_type=Boolean(optional=True), prefix="--man", doc=InputDocumentation(doc="- Bool. Display man page")), ToolInput(tag="in_cpus_per_task", input_type=Boolean(optional=True), prefix="--cpus_per_task", doc=InputDocumentation(doc="- Str. Default=4.")), ToolInput(tag="in_commands_per_node", input_type=Boolean(optional=True), prefix="--commands_per_node", doc=InputDocumentation(doc="- Str. Default=8. Commands to run on each node.\nThis is not the same as\nconcurrent_commands_per_node!")), ToolInput(tag="in_nodes_count", input_type=Boolean(optional=True), prefix="--nodes_count", doc=InputDocumentation(doc="- Str. Default=1. Number of nodes requested.\nYou should only use this if submitting\nparallel jobs.")), ToolInput(tag="in_partition", input_type=Boolean(optional=True), prefix="--partition", doc=InputDocumentation(doc="- Str. Default=. Slurm partition to submit jobs\nto. Defaults to the partition with the most\navailable nodes")), ToolInput(tag="in_wall_time", input_type=Boolean(optional=True), prefix="--walltime", doc=InputDocumentation(doc="- Str. Default=04:00:00.")), ToolInput(tag="in_mem", input_type=Boolean(optional=True), prefix="--mem", doc=InputDocumentation(doc="- Str|Undef. Supply a memory limit")), ToolInput(tag="in_submit_to_slur_m", input_type=Boolean(optional=True), prefix="--submit_to_slurm", doc=InputDocumentation(doc="- Bool. Default=1. Bool value whether or not to\nsubmit to slurm. If you are looking to\ndebug your files, or this script you will\nwant to set this to zero.")), ToolInput(tag="in_outdir", input_type=Directory(optional=True), prefix="--outdir", doc=InputDocumentation(doc="- Str. Directory to write out files.")), ToolInput(tag="in_logdir", input_type=Boolean(optional=True), prefix="--logdir", doc=InputDocumentation(doc="- Str. Directory where logfiles are written.\nDefaults to\ncurrent_working_directory/prunner_current_d\nate_time/log1 .. log2 .. log3'")), ToolInput(tag="in_template_file", input_type=Boolean(optional=True), prefix="--template_file", doc=InputDocumentation(doc="- Str. Path to Slurm template file if you do\nnot wish to use the default")), ToolInput(tag="in_serial", input_type=Boolean(optional=True), prefix="--serial", doc=InputDocumentation(doc="- Bool. Default=0. Use this if you wish to run\neach job run one after another, with each\njob starting only after the previous has\ncompleted successfully")), ToolInput(tag="in_procs", input_type=Boolean(optional=True), prefix="--procs", doc=InputDocumentation(doc="- Int. Default=4. Total number of running jobs\nallowed at any time. The command 'wait' can\nbe used to have a variable number of\nchildren running.")), ToolInput(tag="in_show_processid", input_type=Boolean(optional=True), prefix="--show_processid", doc=InputDocumentation(doc="- Bool. Default=0. Show the process ID per\nlogging message. This is useful when\naggregating logs.")), ToolInput(tag="in_user", input_type=Boolean(optional=True), prefix="--user", doc=InputDocumentation(doc="- Str. This defaults to your current user ID.\nThis can only be changed if running as an\nadmin user")), ToolInput(tag="in_use_threads", input_type=Boolean(optional=True), prefix="--use_threads", doc=InputDocumentation(doc="- Bool. Default=0. Use threads to run jobs")), ToolInput(tag="in_meta_str", input_type=Boolean(optional=True), prefix="--metastr", doc=InputDocumentation(doc="- Str. Default=. Meta str passed from\nHPC::Runner::Scheduler")), ToolInput(tag="in_use_processes", input_type=Boolean(optional=True), prefix="--use_processes", doc=InputDocumentation(doc="- Bool. Default=1. Use processes to run jobs")), ToolInput(tag="in_use_gnu_parallel", input_type=Boolean(optional=True), prefix="--use_gnuparallel", doc=InputDocumentation(doc="- Bool. Default=0. Use gnu-parallel to run jobs\nand manage threads. This is the best option\nif you do not know how many threads your\napplication uses!")), ToolInput(tag="in_custom_command", input_type=Boolean(optional=True), prefix="--custom_command", doc=InputDocumentation(doc="- Str.")), ToolInput(tag="in_logname", input_type=Boolean(optional=True), prefix="--logname", doc=InputDocumentation(doc="- Str. Default=hpcrunner_logs.")), ToolInput(tag="in_process_table", input_type=Boolean(optional=True), prefix="--process_table", doc=InputDocumentation(doc="- Str.")), ToolInput(tag="in_plugins", input_type=Boolean(optional=True), prefix="--plugins", doc=InputDocumentation(doc="- ArrayRef|Str. Add Plugins to your run")), ToolInput(tag="in_slur_m_decides", input_type=Boolean(optional=True), prefix="--slurm_decides", doc=InputDocumentation(doc="- Bool. Default=0.")), ToolInput(tag="in_job_scheduler_id", input_type=Boolean(optional=True), prefix="--job_scheduler_id", doc=InputDocumentation(doc="- Str|Undef. This defaults to your current Job\nScheduler ID. Ignore this if running on a\nsingle node")), ToolInput(tag="in_job_name", input_type=Boolean(optional=True), prefix="--jobname", doc=InputDocumentation(doc="- Str. Specify a job name, each job will be\nappended with its batch order\n"))], outputs=[ToolOutput(tag="out_outdir", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_outdir", type_hint=File()), doc=OutputDocumentation(doc="- Str. Directory to write out files."))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Slurmrunnerbasic_Pl_V0_1_0().translate("wdl", allow_empty_container=True)

